#include <stdio.h>

int main() {
	    /*
	     * Anlegen eines Arrays mit 5 Elementen und Initialisierung
	     */
	int a[5] = {1, 2, 3, 4, 5};
	int i;

	/*
	 * a ist konstanter Zeiger auf das erste Element (a[0]),
	 * daher kann a nicht veraendert werden
	 *
	a = &i;
	*/

	/*
	 * Bestimmung der Adresse von a (a ist Zeiger => kein Adress-Operator)
	 */
	printf("Adresse von a: %08x\n", (int) a);

	/*
	 * "normaler" Zugriff auf die einzelnen Elemente des Arrays
	 * und Bestimmung der Adressen der Elemente
	 */
	for (i = 0; i < 5; i++)
		printf("a[%d] = %d [bei Adresse %08x]\n", i, a[i], (int) &a[i]);

	/*
	 * aequivalenter Zugriff auf die Array-Elemente und Bestimmung der
	 * Adressen (statt &*(a+i) kann man natuerlich auch einfach (a+i) schreiben!)
	 *
	 * so wird intern der Zugriff auf Array-Elemente umgesetzt
	 */
	for (i = 0; i < 5; i++)
		printf("a[%d] = %d [bei Adresse %08x]\n", i, *(a+i), (int) &*(a+i));

	return 0;
}
