#include <stdio.h>

int main() {
	int i;
	int x = 6;
	int a[] = {1, 2, 3, 4};
	int y = 7;

	printf("Adresse von x: %08x\n", (int) &x);
	printf("Adresse von y: %08x\n", (int) &y);
	printf("Adresse von i: %08x\n", (int) &i);
	printf("Adresse von a: %08x\n", (int) a);

	    /*
	     * Zugriff auf zwei nicht vorhandene Array-Elemente,
	     * naemlich a[-1] und a[4]
	     * => hochproblematisch, denn a[-1] = y und a[4] = x,
	     * d.h., wenn man an a[-1] etwas aendert ist das gleichbedeutend
	     * mit einer Aenderung von y und entsprechend fuer a[4] und x;
	     * auf diese Weise kann man schwer zu findende Fehler in ein
	     * Programm einbauen, da sich die Werte von x und y mgl. aendern,
	     * aber auf diese Variablen nicht zugegriffen wird.
	     *
	     * Wie man an der Ausgabe des Programms sieht, kommt y direkt vor a und
	     * dieses wieder direkt vor x im Speicher zu liegen. Dies ist der Grund,
	     * warum a[4] und x, sowie a[-1] und y jeweils Namen fuer dieselbe
	     * Speicherflaeche sind.
	     */
	for (i = -1; i <= 4; i++)
		printf("a[%d] = %d [bei Adresse %08x]\n", i, a[i], (int) &a[i]);

	return 0;
}
