#include <stdio.h>

/*
 * die folgenden 4 Methoden zeigen die verschiedenen Moeglichkeiten
 * der Parameteruebergabe eines Arrays (int b[] bzw. int *b)
 * kombiniert mit den verschiedenen Moeglichkeiten des Zugriffs auf
 * die Array Elemente (b[i] bzw. *(b+i));
 * die Parameter (int b[] und int *b) enthalten keine Groesseninfo
 * des Arrays mehr (kann man einfach mit sizeof(.) ueberpruefen!);
 * daher muss die Groesse des Arrays als separater Parameter mit
 * uebergeben werden!
 */

int sum1(int b[], int length) {
	int sum, i;
	for (i = 0, sum = 0; i < length; i++)
		sum += b[i];
	return sum;
}

int sum2(int b[], int length) {
	int sum, i;
	for (i = 0, sum = 0; i < length; i++)
		sum += *(b+i);
	return sum;
}

int sum3(int *b, int length) {
	int sum, i;
	for (i = 0, sum = 0; i < length; i++)
		sum += b[i];
	return sum;
}

int sum4(int *b, int length) {
	int sum, i;
	for (i = 0, sum = 0; i < length; i++)
		sum += *(b+i);
	return sum;
}

int main() {
	int a[] = {1, 2, 3, 4, 5};

	    /*
	     * Groesse von a bestimmen:
	     */
	int len = sizeof(a) / sizeof(a[0]);

	    /*
	     * Elemente von a aufsummieren:
	     */
	printf("%d\n", sum1(a, len));
	printf("%d\n", sum2(a, len));
	printf("%d\n", sum3(a, len));
	printf("%d\n", sum4(a, len));

	return 0;
}
