#include <stdio.h>

int main() {
	long l = 0x12345678;
	    /*
	     * &l erzeugt Zeiger vom Typ long*
	     * => "type cast" notwendig
	     */
	unsigned char *p = (unsigned char*) &l;
	int i;

	for (i = 0; i < 4; i++)
		/*
		 * Der Wert des Zeigers p (d.h. die Adresse, auf die er zeigt)
		 * wird durch p+i, falls p vom Typ TYP* ist, um i*sizeof(TYP)
		 * inkrementiert; in diesem Fall also um i, da sizeof(unsigned char) = 1.
		 *
		 * VORSICHT: Hier wird auf die einzelnen Bytes
		 * zugegriffen. Folglich spielt die sog. Byte-Order (also
		 * big endian oder little endian) eine grosse Rolle,
		 * was die das Ergebnis angeht.
		 *
		 * Mit dem Wissen aus dem zweiten Teil der Vorlesung koennten
		 * wir statt *(p+i) auch einfach p[i] und statt p+i z.B. auch
		 * &p[i] schreiben.
		 */
		printf("%02x [bei Adresse %08x]\n", *(p+i), (int) p+i);

	return 0;
}
